!
!  SourceFile1.f90
!
!  Free-Format Fortran Source File 
!  Generated by PGI Visual Fortran(R)
!  1/1/2007 12:07:30 AM
!
module Task1mod

	integer(kind=4),private,parameter::STR_WIDTH=60

	public getFileName,isFileExists, calcNumLetters,processFile
	private isCapitalLetter,isSmallLetter

contains

	subroutine getFileName(fileName)

		implicit none

		character(len=*),intent(out)::fileName
		write(*,'(a,i3,a)',advance='no')&
			'Type working file name of maximum',&
			len(fileName), 'symbols: '
		read '(a)',fileName

	end subroutine getFileName

	function isFileExists(fileName)
	
		implicit none

		logical(kind=4)::isFileExists
	
		character(len=*),intent(in)::fileName

		inquire(file=trim(fileName),exist=isFileExists)

	end function isFileExists
	
	function isCapitalLetter(symbol)

		implicit none

		logical(kind=4)::isCapitalLetter
		character(len=1)::symbol

		integer(kind=4)::code
		integer(kind=4),parameter::code_A=65,code_Z=90
	
		code=iachar(symbol)

		isCapitalLetter=.false.
		if((code >= code_A).and.(code <= code_Z))isCapitalLetter=.true.

	end function isCapitalLetter

	function isSmallLetter(symbol)
	
		implicit none

		logical(kind=4)::isSmallLetter
		character(len=1)::symbol

		integer(kind=4)::code
		integer(kind=4),parameter::code_a=97,code_z=122

		code=iachar(symbol)

		isSmallLetter=.false.
		if((code >= code_a).and.(code <= code_z))isSmallLetter=.true.

	end function isSmallLetter

	subroutine CalcNumLetters(fileName,numCapitals,numSmall)

		implicit none

		character(len=*),intent(in)::fileName
		integer(kind=4),intent(out)::numCapitals,numSmall
		
		character(len=STR_WIDTH)::str
		integer(kind=4)::status,i

		open(11,file=fileName,status='old',action='read', iostat=status)
		if(status/=0)then
			print *,'File'//trim(fileName)//'opening error'
			print *,trim(str)
			stop 'Check Error and restart the program'
		end if

		numCapitals=0; numSmall=0
		do
			read(11,'(a)',iostat=status)str
			if (status/=0)exit
			do i=1,len_trim(str)
				if(isCapitalLetter(str(i:i)))numCapitals=numCapitals+1
				if(isSmallLetter(str(i:i)))numSmall=numSmall+1
			end do
		end do

		close(11,status='keep')

	end subroutine calcNumLetters



	subroutine processFile(fileName,toBig)

		implicit none

		character(len=*),intent(in)::fileName
		logical(kind=4),intent(in)::toBig
		
		integer(kind=4)::status
		character(len=STR_WIDTH)::str

		open(33,status='scratch',action='readwrite',&
			iostat=status)
		if(status/=0)then
			print *,'Scratch File opening error'
			print *,trim(str)
			stop 'Check Error and restart the program'
		end if

		call writeTmpFile()
		rewind(33)

		open(44,file=fileName,status='new',action='write',&
			iostat=status)
		if(status/=0)then
			print *,'File'//trim(fileName)//'opening error'
			print *,trim(str)
			stop 'Check Error and restart the program'
		end if

		do
			read(33,'(a)',iostat=status)str
			if (status/=0)exit
			if(toBig)then
				call convertString(str,.true.)
			else
				call convertString(str,.false.)
			end if
			write(44,'(a)')str
		end do

		close(33); close(44,status='keep')

	contains
		
		subroutine writeTmpFile()

		open(22,file=fileName,status='old',action='read',iostat=status)
		if(status/=0)then
			print *,'File'//trim(fileName)//'opening error'
			print *,trim(str)
			stop 'Check Error and restart the program'
		end if

		do
			read(22,'(a)',iostat=status)str
			if (status/=0)exit
			write(33,'(a)')trim(str)
		end do

		close(22,status='delete')

		end subroutine writeTmpFile

		subroutine convertString(str,toBigLetters)

		implicit none

		character(len=*),intent(out)::str
		logical(kind=4),intent(in)::toBigLetters
		
		integer(kind=4)::i

		do i=1,len_trim(str)
			if(toBigLetters)then
				if(isSmallLetter(str(i:i)))str(i:i)=achar(iachar(str(i:i))-32)
			else
				if(isCapitalLetter(str(i:i)))str(i:i)=achar(iachar(str(i:i))+32)
			end if
		end do

		end subroutine convertString


	end subroutine processFile



end module Task1mod