      module NIntegr
	    contains
		  function rightRectIntegrate(f, a, b, h)
		    external f

		    real(kind = 8), intent(in):: a, b, h
			real(kind = 8):: x_curr, y_summ, rightRectIntegrate
		    integer(kind = 4) n, i

			if (h < (a - b)) then 
			  h = (a - b)/100
			endif
			if (a < b) then
			  x_curr = a
			else 
			  x_curr = b
			end if
			y_summ = 0
			n = abs(a - b) / h

			do i = 0, (n-1)
			  y_summ = y_summ + f(x_curr)
			  x_curr = x_curr + h
			end do
			rightRectIntegrate = y_summ * h
		  end function rightRectIntegrate
		  !--------------------------------
		  function leftRectIntegrate(f, a, b, h)
		    external f

		    real(kind = 8), intent(in):: a, b, h
			real(kind = 8):: x_curr, y_summ, leftRectIntegrate
		    integer(kind = 4) n, i

			if (h < (a - b)) h = (a - b)/100
			if (a < b) then
			  x_curr = a + h
			else 
			  x_curr = b + h
			end if
			y_summ = 0
			n = abs(a - b) / h

			do i = 0, (n-1)
			  y_summ = y_summ + f(x_curr)
			  x_curr = x_curr + h
			end do
			leftRectIntegrate = y_summ * h
		  end function leftRectIntegrate

		  function middleRectIntegrate(f, a, b, h)
		    external f

		    real(kind = 8), intent(in):: a, b, h
			real(kind = 8):: x_curr, y_summ, middleRectIntegrate
		    integer(kind = 4) n, i

			if (h < (a - b)) then 
			  h = (a - b)/100
			endif
			if (a < b) then
			  x_curr = a
			else 
			  x_curr = b
			end if
			y_summ = 0
			n = abs(a - b) / h

			do i = 0, (n-1)
			  y_summ = y_summ + f(x_curr + h/2)
			  x_curr = x_curr + h
			end do
			middleRectIntegrate = y_summ * h
		  end function middleRectIntegrate

	  end module NIntegr