      module NDeriv

	  contains
		function der3t(f, x, h, eps)
		  external f

		  real(kind = 8) dn_next, dn, dn_last
		  real(kind = 8), intent(in):: x, h, eps
		  integer(kind = 4) k

		  k = 0
		  dn_last = der3t_D(x, h, k)
		  k = k + 1
		  dn = der3t_D(x, h, k)
		  k = k + 1
		  dn_first = der3t_D(x, h, k)
         
		  do while ((abs(dn_first - dn) < abs(dn - dn_last)).AND.(abs(dn - dn_last) >= eps))
		    dn_last = dn
			dn = dn_first
			k = k + 1
			dn_first = der3t_D(x, h, k)
		  end do

		  der3t = dn
		  contains 
		    !   D
		    function der3t_D(x, h, k)
			  real(kind = 8), intent(in):: x, h
			  integer(kind = 4), intent(in):: k

			  der3t_D = ( f(x + (10.0**(-k))*h ) - f( x - (10.0**(-k))*h )) / (2*(10.0**(-k)*h) )
			end function der3t_D

		end function der3t
	  end module NDeriv