!
!  ConsoleApp.f90
!
!  Fortran Console Application 
!  Generated by PGI Visual Fortran(R)
!  07.04.2013 11:15:16
!
      module TestFunc

	    private:: f, g
	    public testFun
	  contains

	  !  
	  function f(x)

	    implicit none

		real(kind=8)::f
		real(kind=8), intent(in)::x

		f = sin(x) * exp(-x)

	  end function f

	  !  
	  function g(x)

	    implicit none
		real(kind=8)::g
		real(kind=8), intent(in)::x

		g = sin(cos(x)**2)

	  end function g
	  
	  !  
	  function testFun(x)
	    use NDeriv
	    use NIntegr

	    implicit none

	    real(kind=8)::testFun
	    real(kind=8), intent(in)::x

	    real(kind=8)::der, int, h, eps

		h = 0.1
		eps = 0.0001
	    !der =  der3t(f, x, h, eps)
	    !int = rightRectIntegrate(g, 0.0d0, x, h) 

	    testFun = der*int

	  end function testFun
	  end module TestFunc

	  ! 
      program TestLibrary
	  
	  use TestFunc
      implicit none

      real(kind=8) :: xBeg, xEnd, xStep
	  real(kind=8) :: res
	  integer(kind = 4):: ioStatus

	  call GetData()

	  open (11, file ="Result.dat", iostat=ioStatus)
	  if (ioStatus /= 0) stop "Error while opening file 'Result.dat'"
	  write(11, '(a5, 9x, a6)') "X", "Y"

	  do while(xBeg <= xEnd)
	    res = testFun(xBeg)
		print 100, xBeg, res
		write(11, '(e10.4, 4x, e12.6)') xBeg,  res
		xBeg = xBeg + xStep
	  end do

	  close(11)

	  100 format(7x, "x = ", e10.4, 4x, "f(x) = ", e12.6)
	contains
	  subroutine getData()

	    xBeg = 0.0d0; xEnd = 6.0d0;
		
		do
		  print '(1x, a, $)', "Type X step value: "
		  read *, xStep
		  if((xStep > 0.0d0).AND.(xStep <= 5.0d-1)) exit
		end do

		print "(3x, '1). start: ', e10.4)", xBeg
		print "(3x, '1). stop: ', e10.4)", xEnd
		print "(3x, '1). step: ', e10.4)", xStep

		pause 'Press <Enter> to continue the program...'

		xEnd = xEnd + 1.0d-1 * xStep

	  end subroutine getData

      end program TestLibrary
