      module NDSolve
	  contains
	    subroutine addToResultFile(t, w, h)
		implicit none

		  real(kind = 8), intent(in)::t, w
		  real(kind = 8), intent(in), optional:: h
	      open(12, file = "result.ini", status = "old", position = "APPEND")
		  if (present(h)) then
	        write(12, *) t, w, h
		  else 
		    write(12, *) t, w
		  end if
	      close(12)
		end subroutine addToResultfile

	    subroutine RK5(f, xStart, xEnd, yStart, yEnd, tol, hMax, hMin)
		  external f

		  real(kind = 8), intent(in)::xStart, xEnd, yStart, tol, hMax, hMin
	      real(kind = 8), intent(out)::yEnd
		  real(kind = 8):: t, w, h, k1, k2, k3, k4, k5, k6, R, delt
		  logical flag

	      open(12, file = "result.ini", status = "replace")
	      close(12)

          !Step 1
		  t = xStart
		  w = yStart
		  h = hMax
		  flag = .TRUE.
		  call addToResultFile(t, w)

		  !Step 2
		  do while (flag)
		    !Step 3
			k1 = h * f(t, w)
			k2 = h * f(t + h/4, w + k1/4)
			k3 = h * f(t + 3.*h/8, w + k1*3/32 + 9*k2/32)
			k4 = h * f(t + 12.*h/13., w + k1*1932/2197 - k2*7200/2197 + k3*7296/2197)
			k5 = h * f(t + h, w + k1*439/216 - k2*8 + k3*3680/513 - k4*845/4104)
			k6 = h * f(t + h/2, w - k1*827 + k2*2 - k3*3544/2565 + k4*1859/4104 - k5*11/40)
			!Step 4
			R = abs(k1/360 - k3*128/4275 - k4*2197/75240 + k5/50 + k6*2/55)/h
			!Step 5
			if (R <= tol) then
			  !Step 6
			  t = t + h
			  w = w + k1*25/216 + k3*1408/2565 + k4*2197/4104 - k5/5
			  !Step 7
			  !call addToResultFile(t, w, h)
			  call addToResultFile(t, w)
			end if
			!Step 8
			delt = 0.84*((tol/R)**(0.25))
			!Step 9
			if (delt <= 0.1) then
			  h = 0.1*h
			else if (delt >= 4) then
			  h = 4*h
			else
			  h = delt*h
			endif
			!Step 10
			if (h > hMax) h = hMax
			!Step 11
			if (t >= xEnd) then 
			  flag = .FALSE.
			else if ((t + h) > xEnd) then
			  h = xEnd - t
			else if (h < hMin) then
			  flag = .FALSE.
			  open(12, file = "result.ini", status = "old", position = "APPEND")
	          write(12, *) "Step must be less than the minimum step"
	          close(12)
			end if
		  end do
		  !step 12
		  yEnd = w
		end subroutine RK5
	  end module NDSolve