      module Task2mod

	    integer(kind=4), allocatable, private :: a(:)
		integer(kind=4), save, private :: num

	  contains 
	    !   
		function isFileExists(fileName) 

		  implicit none

		  character(len=*), intent(in)::fileName
		  logical(kind=4):: isFileExists

		  inquire(file=trim(fileName), exist=isFileExists)
		end function isFileExists
		
		! 
		subroutine getArray(fileName) 

		  implicit none

		  character(len=*), intent(in) :: fileName

		  integer(kind=4) :: i, error
		  character(len=80) :: msg

		  if (isFileExists(trim(fileName))) then 
		    print *, 'Read array and write to the file: ' // trim(fileName)
			call readArray()
		  else
			call makeArray()
			call writeArray()
		  end if

		contains
		!   
		  subroutine readArray()
		    open(33, file=trim(fileName), form='unformatted', &
			    status='old', action='read', iostat=error, iomsg=msg)
			if (error /= 0) then
			  print *, 'IoError while openning file' //trim(fileName)
			  print *, trim(msg)
			  stop 'IOError!'
			end if

			read(33) num
			call constructArray()
			read(33) a
			close(33, status='keep') 
		  end subroutine readArray

		  subroutine makeArray()

		    character(len=1) ::ans
			integer(kind=4), parameter::LEFT = -50, RIGHT = 50
			real(kind=4)::x

			do
			  print'(a,$)', 'Number of elements:'
			  read *, num
			  if (num > 0) exit
			  print *, 'Number of elements must be positive'
			end do

			call constructArray()
			!       
			print *, 'Type y or Y to manual input or any other to authomatic'
			print '(3x, a, $)', '-> '
			read *, ans

			if ((ans=='y').OR.(ans=='Y')) then
			  print *, 'Manual'
			  print '("Type ", i3, " elements")', num
			  do i = 1, num 
			    print '(5x, "num ", i2, ": ", $)', i
				read *, a(i)
			  end do
			else 
			  print *, 'Authomatic'
			  call random_seed()
			  do i = 1, num
			    call random_number(x)
				  a(i) = nint(LEFT + (RIGHT-LEFT)*x) 
				end do 
			end if

		  end subroutine makeArray
		  !  
		  subroutine writeArray()
		    open(22, file = trim(fileName), form='unformatted', &
			     status='new', action='write', &
				 iostat=error, iomsg=msg)
			if (error /= 0) then
              print *, 'IoError while openning file ' //trim(fileName)
			  print *, trim(msg)
			  stop 'IOError!'
			end if

			write(22) num
			write(22) a
			close(22, status='keep')
		  end subroutine writeArray
		end subroutine getArray
		!===============================
		subroutine constructArray()
		 implicit none

		 integer(kind=4) :: error

		 allocate(a(1:num), stat=error) 
		 if (error /= 0) stop 'Allocation memory error'

		end subroutine constructArray
		!===============================
		subroutine destroyArray()
		  implicit none

		  integer(kind=4) ::error

		  deallocate(a, stat=error)
		  if (error /= 0) stop 'Deallocation memory error'

		end subroutine destroyArray
		!  
		subroutine printArray()
		  implicit none

		  integer(kind=4) :: i

		  do i= 1, num
		    print '(i4, $)', a(i)
		  end do
		  print *
		end subroutine printArray
		!  
		function findMin()
		  implicit none

		  integer(kind = 4):: findMin
		  integer(kind = 4):: i, min 
		  call constructArray()
		  min = a(1)
		  do i= 1, num
		    if (a(i) < min) min = a(i) 
		  end do
		  findMin = min
		end function findMin
		!   
		function findMax()
		  implicit none

		  integer(kind = 4):: findMax
		  integer(kind = 4):: i, max 
		  
		  call constructArray()
		  max = a(1)
		  do i= 1, num
		    if (a(i) > max) max = a(i) 
		  end do
		  findMax = max
		end function findMax
	  end module Task2mod