      module Task4mod

	    real(kind=8), allocatable, private :: a(:)
		integer(kind=4), save, private :: num

	  contains 
	    !   
		function isFileExists(fileName) 

		  implicit none

		  character(len=*), intent(in)::fileName
		  logical(kind=4):: isFileExists

		  inquire(file=trim(fileName), exist=isFileExists)
		end function isFileExists
		
		! 
		subroutine getArray(fileName) 

		  implicit none

		  character(len=*), intent(in) :: fileName

		  integer(kind=4) :: i, error
		  character(len=80) :: msg

		  if (isFileExists(trim(fileName))) then 
		    print *, 'Read array and write to the file: ' // trim(fileName)
			call readArray()
		  else
			call makeArray()
			call writeArray()
		  end if

		contains
		!   
		  subroutine readArray()
		    open(33, file=trim(fileName), form='unformatted', &
			    status='old', action='read', iostat=error, iomsg=msg)
			if (error /= 0) then
			  print *, 'IoError while openning file' //trim(fileName)
			  print *, trim(msg)
			  stop 'IOError!'
			end if

			read(33) num
			call constructArray()
			read(33) a
			close(33, status='keep') 
		  end subroutine readArray

		  subroutine makeArray()

		    character(len=1) ::ans
			integer(kind=4), parameter::LEFT = -50, RIGHT = 50
			real(kind=4)::x

			do
			  print'(a,$)', 'Number of elements:'
			  read *, num
			  if (num > 0) exit
			  print *, 'Number of elements must be positive'
			end do

			call constructArray()
			!       
			print *, 'Type y or Y to manual input or any other to authomatic'
			print '(3x, a, $)', '-> '
			read *, ans

			if ((ans=='y').OR.(ans=='Y')) then
			  print *, 'Manual'
			  print '("Type ", i3, " elements")', num
			  do i = 1, num 
			    print '(5x, "num ", i2, ": ", $)', i
				read *, a(i)
			  end do
			else 
			  print *, 'Authomatic'
			  call random_seed()
			  do i = 1, num
			    call random_number(x)
				  a(i) = nint(LEFT + (RIGHT-LEFT)*x) 
				end do 
			end if

		  end subroutine makeArray
		  !  
		  subroutine writeArray()
		    open(22, file = trim(fileName), form='unformatted', &
			     status='new', action='write', &
				 iostat=error, iomsg=msg)
			if (error /= 0) then
              print *, 'IoError while openning file ' //trim(fileName)
			  print *, trim(msg)
			  stop 'IOError!'
			end if

			write(22) num
			write(22) a
			close(22, status='keep')
		  end subroutine writeArray
		end subroutine getArray
		!===============================
		subroutine constructArray()
		 implicit none

		 integer(kind=4) :: error

		 allocate(a(1:num), stat=error) 
		 if (error /= 0) stop 'Allocation memory error'

		end subroutine constructArray
		!===============================
		subroutine destroyArray()
		  implicit none

		  integer(kind=4) ::error

		  deallocate(a, stat=error)
		  if (error /= 0) stop 'Deallocation memory error'

		end subroutine destroyArray
		!  
		subroutine printArray()
		  implicit none

		  integer(kind=4) :: i

		  do i= 1, num
		    print *, a(i)
		  end do
		  print *
		end subroutine printArray
		!   
		function findCountMoreAverage()
		  implicit none

		  integer(kind = 4):: findCountMoreAverage
		  real(kind = 4):: aver 
		  integer(kind = 4):: i, count
		  
		  count = 0 
		  
		  aver = findAverage()

		  do i = 1, num 
		    if (a(i) > aver ) count = count + 1
		  end do 

		  findCountMoreAverage = count
		contains
		  function findAverage()
		    implicit none

		    real(kind = 4):: findAverage, sum
		    integer(kind = 4):: i
		    
		    sum = 0;
		    
		    do i= 1, num
		      sum = sum + a(i) 
		    end do
		    findAverage = sum / num
		  end function findAverage
		end function findCountMoreAverage
		

		function sumAfterFirstPositive()
		  implicit none 

		  real(kind = 4):: sumAfterFirstPositive, sum
		  integer(kind = 4):: i
		  do i = 1, num  
		    if (a(i) > 0) then
			  sum = sumFromElementToEnd(i)
		      exit
			end if
		  end do 

		  sumAfterFirstPositive = sum
		contains 
		  function sumFromElementToEnd(start)
			
			real(kind = 4):: sumFromElementToEnd, sum
		    integer(kind = 4):: i, start

			sum = 0;

			do i = start+1, num
			  sum = sum + a(i) 
			end do 

			sumFromElementToEnd = sum;
		  end function sumFromElementToEnd
		end function sumAfterFirstPositive

	  end module Task4mod