(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     24535,        679]
NotebookOptionsPosition[     23433,        635]
NotebookOutlinePosition[     23776,        650]
CellTagsIndexPosition[     23733,        647]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{
  RowBox[{"ode", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"y", "'"}], "[", "t", "]"}], "\[Equal]", 
    RowBox[{
     RowBox[{"y", "[", "t", "]"}], "-", 
     RowBox[{"t", "^", "2"}], "+", "1"}]}]}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.37658933640625*^9, 3.376589342609375*^9}, {
  3.3765894476875*^9, 3.376589457390625*^9}, {3.376589996375*^9, 
  3.376590056109375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["y", "\[Prime]",
    MultilineFunction->None], "[", "t", "]"}], "\[Equal]", 
  RowBox[{"1", "-", 
   SuperscriptBox["t", "2"], "+", 
   RowBox[{"y", "[", "t", "]"}]}]}]], "Output",
 CellChangeTimes->{3.376590058609375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"init", "=", 
  RowBox[{
   RowBox[{"y", "[", "0", "]"}], "\[Equal]", 
   RowBox[{
    RowBox[{"-", "1"}], "/", "2"}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"y", "[", "0", "]"}], "\[Equal]", 
  RowBox[{"-", 
   FractionBox["1", "2"]}]}]], "Output",
 CellChangeTimes->{3.376590070828125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res1", "=", 
  RowBox[{"DSolve", "[", 
   RowBox[{"ode", ",", "y", ",", "t"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.376590076375*^9, 3.37659010334375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"y", "\[Rule]", 
    RowBox[{"Function", "[", 
     RowBox[{
      RowBox[{"{", "t", "}"}], ",", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "+", "t"}], ")"}], "2"], "+", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", "t"], " ", 
        RowBox[{"C", "[", "1", "]"}]}]}]}], "]"}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.376590150375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res1", "=", 
  RowBox[{"DSolve", "[", 
   RowBox[{"ode", ",", 
    RowBox[{"y", "[", "t", "]"}], ",", "t"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.376590156265625*^9, 3.37659016025*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"y", "[", "t", "]"}], "\[Rule]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "+", "t"}], ")"}], "2"], "+", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", "t"], " ", 
      RowBox[{"C", "[", "1", "]"}]}]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.3765901655*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res2", "=", 
  RowBox[{"DSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ode", ",", "init"}], "}"}], ",", "y", ",", "t"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.37659019275*^9, 3.376590229640625*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"y", "\[Rule]", 
    RowBox[{"Function", "[", 
     RowBox[{
      RowBox[{"{", "t", "}"}], ",", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"2", "-", 
         RowBox[{"3", " ", 
          SuperscriptBox["\[ExponentialE]", "t"]}], "+", 
         RowBox[{"4", " ", "t"}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox["t", "2"]}]}], ")"}]}]}], "]"}]}], "}"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.376590233859375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"resNum", "=", 
  RowBox[{"NDSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ode", ",", "init"}], "}"}], ",", "y", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "2"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.376590255296875*^9, 3.37659029365625*^9}, {
  3.37659036703125*^9, 3.376590373734375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"y", "\[Rule]", 
    TagBox[
     RowBox[{"InterpolatingFunction", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0.`", ",", "2.`"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], "]"}],
     False,
     Editable->False]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.3765903810625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{"y", "[", "t", "]"}], "]"}], "/.", "resNum"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.3765903970625*^9, 3.37659047890625*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVl3k8VP0Xx0cpRIRKlCTSKp6SKDlPVBIqpYWnVJJSlCxlqexrlhJSFJUW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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 2}, {-2.0835838962339635`, 0.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.376590485578125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TableForm", "[", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"t", ",", 
      RowBox[{
       RowBox[{"Evaluate", "[", 
        RowBox[{"y", "[", "t", "]"}], "]"}], "/.", "resNum"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "2", ",", "0.1"}], "}"}]}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.376590513765625*^9, 3.37659058078125*^9}, {
  3.376590624828125*^9, 3.376590643796875*^9}}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {"0.`", GridBox[{
       {
        RowBox[{"-", "0.5`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"0.1`", GridBox[{
       {
        RowBox[{"-", "0.44775635056234525`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"0.2`", GridBox[{
       {
        RowBox[{"-", "0.3921040652945355`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"0.30000000000000004`", GridBox[{
       {
        RowBox[{"-", "0.33478814424649644`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"0.4`", GridBox[{
       {
        RowBox[{"-", "0.277737012521831`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"0.5`", GridBox[{
       {
        RowBox[{"-", "0.22308185499376737`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"0.6000000000000001`", GridBox[{
       {
        RowBox[{"-", "0.17317816263478944`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"0.7000000000000001`", GridBox[{
       {
        RowBox[{"-", "0.13062903467442055`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"0.8`", GridBox[{
       {
        RowBox[{"-", "0.09831134068375484`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"0.9`", GridBox[{
       {
        RowBox[{"-", "0.0794045493989327`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"1.`", GridBox[{
       {
        RowBox[{"-", "0.07742251292607448`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"1.1`", GridBox[{
       {
        RowBox[{"-", "0.09624865115563916`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"1.2000000000000002`", GridBox[{
       {
        RowBox[{"-", "0.1401748066719525`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"1.3`", GridBox[{
       {
        RowBox[{"-", "0.21394420066901898`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"1.4000000000000001`", GridBox[{
       {
        RowBox[{"-", "0.3227989049335156`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"1.5`", GridBox[{
       {
        RowBox[{"-", "0.47253181534569927`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"1.6`", GridBox[{
       {
        RowBox[{"-", "0.6695470309399469`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"1.7000000000000002`", GridBox[{
       {
        RowBox[{"-", "0.9209197765976372`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"1.8`", GridBox[{
       {
        RowBox[{"-", "1.2344702722892453`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"1.9000000000000001`", GridBox[{
       {
        RowBox[{"-", "1.6188415235232834`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"2.`", GridBox[{
       {
        RowBox[{"-", "2.0835841037271847`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  TableForm[{{0., {-0.5}}, {0.1, {-0.44775635056234525`}}, {
    0.2, {-0.3921040652945355}}, {
    0.30000000000000004`, {-0.33478814424649644`}}, {
    0.4, {-0.277737012521831}}, {0.5, {-0.22308185499376737`}}, {
    0.6000000000000001, {-0.17317816263478944`}}, {
    0.7000000000000001, {-0.13062903467442055`}}, {
    0.8, {-0.09831134068375484}}, {0.9, {-0.0794045493989327}}, {
    1., {-0.07742251292607448}}, {1.1, {-0.09624865115563916}}, {
    1.2000000000000002`, {-0.1401748066719525}}, {
    1.3, {-0.21394420066901898`}}, {
    1.4000000000000001`, {-0.3227989049335156}}, {
    1.5, {-0.47253181534569927`}}, {1.6, {-0.6695470309399469}}, {
    1.7000000000000002`, {-0.9209197765976372}}, {
    1.8, {-1.2344702722892453`}}, {
    1.9000000000000001`, {-1.6188415235232834`}}, {
    2., {-2.0835841037271847`}}}]]], "Output",
 CellChangeTimes->{3.37659065965625*^9}]
}, Open  ]]
},
WindowSize->{615, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"7.0 for Microsoft Windows (32-bit) (November 10, 2008)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 422, 12, 52, "Input"],
Cell[992, 36, 275, 8, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1304, 49, 155, 5, 31, "Input"],
Cell[1462, 56, 167, 5, 47, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1666, 66, 183, 4, 31, "Input"],
Cell[1852, 72, 453, 14, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2342, 91, 213, 5, 31, "Input"],
Cell[2558, 98, 377, 12, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2972, 115, 241, 7, 31, "Input"],
Cell[3216, 124, 536, 17, 47, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3789, 146, 352, 9, 31, "Input"],
Cell[4144, 157, 368, 12, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4549, 174, 300, 8, 31, "Input"],
Cell[4852, 184, 6022, 105, 230, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10911, 294, 466, 13, 31, "Input"],
Cell[11380, 309, 12037, 323, 362, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

