(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     65706,       2305]
NotebookOptionsPosition[     58928,       2062]
NotebookOutlinePosition[     59274,       2077]
CellTagsIndexPosition[     59231,       2074]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"FullForm", "[", "expr", "]"}]], "Input",
 CellChangeTimes->{{3.376602830390625*^9, 3.376603104890625*^9}, {
  3.376603240046875*^9, 3.376603261359375*^9}, {3.37660333653125*^9, 
  3.376603360671875*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox["expr",
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellChangeTimes->{3.376603362390625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plus", "[", 
  RowBox[{"a", ",", "b", ",", "c"}], "]"}]], "Input",
 CellChangeTimes->{{3.376603368578125*^9, 3.376603369296875*^9}}],

Cell[BoxData[
 RowBox[{"a", "+", "b", "+", "c"}]], "Output",
 CellChangeTimes->{3.376603369734375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lst", "=", 
  RowBox[{"{", 
   RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.376603373640625*^9, 3.376603394875*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.376603374515625*^9, 3.37660339553125*^9}, 
   3.37660418171875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apply", "[", 
  RowBox[{"Plus", ",", "lst"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"a", "+", "b", "+", "c", "+", "d", "+", "e", "+", "f"}]], "Output",
 CellChangeTimes->{{3.376603377125*^9, 3.376603397921875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Apply", "[", 
   RowBox[{"Plus", ",", "lst"}], "]"}], "/", 
  RowBox[{"Length", "[", "lst", "]"}]}]], "Input",
 CellChangeTimes->{{3.376603383640625*^9, 3.37660338709375*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "6"], " ", 
  RowBox[{"(", 
   RowBox[{"a", "+", "b", "+", "c", "+", "d", "+", "e", "+", "f"}], 
   ")"}]}]], "Output",
 CellChangeTimes->{{3.37660338828125*^9, 3.376603399953125*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"f", ",", "lst"}], "]"}]], "Input",
 CellChangeTimes->{{3.37660340971875*^9, 3.376603416375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"f", "[", "a", "]"}], ",", 
   RowBox[{"f", "[", "b", "]"}], ",", 
   RowBox[{"f", "[", "c", "]"}], ",", 
   RowBox[{"f", "[", "d", "]"}], ",", 
   RowBox[{"f", "[", "e", "]"}], ",", 
   RowBox[{"f", "[", "f", "]"}]}], "}"}]], "Output",
 CellChangeTimes->{3.376603416984375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "=", 
  RowBox[{"a", "*", "b", "*", "c"}]}]], "Input",
 CellChangeTimes->{{3.376603434*^9, 3.37660343565625*^9}}],

Cell[BoxData[
 RowBox[{"a", " ", "b", " ", "c"}]], "Output",
 CellChangeTimes->{3.37660343659375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"f", ",", "expr"}], "]"}]], "Input",
 CellChangeTimes->{{3.376603426421875*^9, 3.37660344065625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "a", "]"}], " ", 
  RowBox[{"f", "[", "b", "]"}], " ", 
  RowBox[{"f", "[", "c", "]"}]}]], "Output",
 CellChangeTimes->{{3.3766034285625*^9, 3.37660344121875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Times", "[", 
  RowBox[{"a", ",", "b", ",", "c"}], "]"}]], "Input",
 CellChangeTimes->{{3.37660348625*^9, 3.376603504578125*^9}}],

Cell[BoxData[
 RowBox[{"a", " ", "b", " ", "c"}]], "Output",
 CellChangeTimes->{3.37660350828125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Times", "[", 
  RowBox[{"a", ",", "b", ",", 
   RowBox[{"Power", "[", 
    RowBox[{"c", ",", 
     RowBox[{"-", "1"}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.376603527640625*^9, 3.376603556328125*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{"a", " ", "b"}], "c"]], "Output",
 CellChangeTimes->{3.376603559984375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lst", "=", 
  RowBox[{"{", 
   RowBox[{"b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", "h"}], 
   "}"}]}]], "Input",
 CellChangeTimes->{{3.37660387684375*^9, 3.376603918453125*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", "h"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.37660391190625*^9, 3.376603919546875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apply", "[", 
  RowBox[{"Times", ",", "lst"}], "]"}]], "Input",
 CellChangeTimes->{{3.3766039518125*^9, 3.3766039728125*^9}}],

Cell[BoxData[
 RowBox[{"b", " ", "c", " ", "d", " ", "e", " ", "f", " ", "g", " ", 
  "h"}]], "Output",
 CellChangeTimes->{3.376603976203125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["3 Point Central Formula", "Section",
 CellChangeTimes->{{3.376604038703125*^9, 3.376604091671875*^9}, {
  3.376604149875*^9, 3.37660416103125*^9}}],

Cell[BoxData[{
 RowBox[{"Clear", "[", "\"\<Global`*\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"num", "=", "3"}], ";"}]}], "Input",
 CellChangeTimes->{{3.376604222984375*^9, 3.376604406734375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xVals", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"x0", "+", 
     RowBox[{"i", "*", "h"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{"num", "-", "1"}], ")"}]}], "/", "2"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"num", "-", "1"}], ")"}], "/", "2"}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.376604413015625*^9, 3.376604413328125*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "h"}], "+", "x0"}], ",", "x0", ",", 
   RowBox[{"h", "+", "x0"}]}], "}"}]], "Output",
 CellChangeTimes->{3.37660441503125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"yVals", "=", 
  RowBox[{"f", "/@", "xVals"}]}]], "Input",
 CellChangeTimes->{{3.3766044205625*^9, 3.376604420984375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{
     RowBox[{"-", "h"}], "+", "x0"}], "]"}], ",", 
   RowBox[{"f", "[", "x0", "]"}], ",", 
   RowBox[{"f", "[", 
    RowBox[{"h", "+", "x0"}], "]"}]}], "}"}]], "Output",
 CellChangeTimes->{3.376604421859375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pts", "=", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"xVals", ",", "yVals"}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.37660442803125*^9, 3.376604505546875*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "h"}], "+", "x0"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{
       RowBox[{"-", "h"}], "+", "x0"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x0", ",", 
     RowBox[{"f", "[", "x0", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"h", "+", "x0"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"h", "+", "x0"}], "]"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.376604465671875*^9, 3.37660451159375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "[", "i", "]"}], "*", 
    RowBox[{"x", "^", "i"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", 
     RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.37660455053125*^9, 3.376604689671875*^9}, {
  3.376604739109375*^9, 3.376604756984375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"a", "[", "0", "]"}], ",", 
   RowBox[{"x", " ", 
    RowBox[{"a", "[", "1", "]"}]}], ",", 
   RowBox[{
    SuperscriptBox["x", "2"], " ", 
    RowBox[{"a", "[", "2", "]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.3766048054375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plus", "@@", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "i", "]"}], "*", 
     RowBox[{"x", "^", "i"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "0", ",", 
      RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.37660481540625*^9, 3.37660482525*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", "0", "]"}], "+", 
  RowBox[{"x", " ", 
   RowBox[{"a", "[", "1", "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["x", "2"], " ", 
   RowBox[{"a", "[", "2", "]"}]}]}]], "Output",
 CellChangeTimes->{3.376604833125*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"eq", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Plus", "@@", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", "i", "]"}], "*", 
       RowBox[{"x", "^", "i"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "0", ",", 
        RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "\[Equal]", 
   "y"}]}]], "Input",
 CellChangeTimes->{{3.376604852640625*^9, 3.376604878765625*^9}, {
  3.376604918234375*^9, 3.37660494153125*^9}, {3.376605024421875*^9, 
  3.376605033828125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EqSyst", "=", 
  RowBox[{"eq", "/@", "pts"}]}]], "Input",
 CellChangeTimes->{{3.376605052859375*^9, 3.37660508734375*^9}, {
  3.376605155453125*^9, 3.376605156046875*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "0", "]"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "h"}], "+", "x0"}], ")"}], " ", 
      RowBox[{"a", "[", "1", "]"}]}], "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "h"}], "+", "x0"}], ")"}], "2"], " ", 
      RowBox[{"a", "[", "2", "]"}]}]}], "\[Equal]", 
    RowBox[{"f", "[", 
     RowBox[{
      RowBox[{"-", "h"}], "+", "x0"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "0", "]"}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"a", "[", "1", "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["x0", "2"], " ", 
      RowBox[{"a", "[", "2", "]"}]}]}], "\[Equal]", 
    RowBox[{"f", "[", "x0", "]"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "0", "]"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"h", "+", "x0"}], ")"}], " ", 
      RowBox[{"a", "[", "1", "]"}]}], "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"h", "+", "x0"}], ")"}], "2"], " ", 
      RowBox[{"a", "[", "2", "]"}]}]}], "\[Equal]", 
    RowBox[{"f", "[", 
     RowBox[{"h", "+", "x0"}], "]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.37660509059375*^9, 3.37660515865625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Array", "[", 
  RowBox[{"a", ",", "num", ",", "0"}], "]"}]], "Input",
 CellChangeTimes->{{3.376605162890625*^9, 3.376605215328125*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"a", "[", "0", "]"}], ",", 
   RowBox[{"a", "[", "1", "]"}], ",", 
   RowBox[{"a", "[", "2", "]"}]}], "}"}]], "Output",
 CellChangeTimes->{3.37660521875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{"eqSyst", ",", 
   RowBox[{"Array", "[", 
    RowBox[{"a", ",", "num", ",", "0"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.376605228640625*^9, 3.37660524809375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "0", "]"}], "\[Rule]", 
     RowBox[{"-", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"2", " ", 
         SuperscriptBox["h", "2"]}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          SuperscriptBox["h", "2"], " ", 
          RowBox[{"f", "[", "x0", "]"}]}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox["x0", "2"], " ", 
          RowBox[{"f", "[", "x0", "]"}]}], "-", 
         RowBox[{"h", " ", "x0", " ", 
          RowBox[{"f", "[", 
           RowBox[{
            RowBox[{"-", "h"}], "+", "x0"}], "]"}]}], "-", 
         RowBox[{
          SuperscriptBox["x0", "2"], " ", 
          RowBox[{"f", "[", 
           RowBox[{
            RowBox[{"-", "h"}], "+", "x0"}], "]"}]}], "+", 
         RowBox[{"h", " ", "x0", " ", 
          RowBox[{"f", "[", 
           RowBox[{"h", "+", "x0"}], "]"}]}], "-", 
         RowBox[{
          SuperscriptBox["x0", "2"], " ", 
          RowBox[{"f", "[", 
           RowBox[{"h", "+", "x0"}], "]"}]}]}], ")"}]}]}]}], ",", 
    RowBox[{
     RowBox[{"a", "[", "1", "]"}], "\[Rule]", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "x0", " ", 
         RowBox[{"f", "[", "x0", "]"}]}], "+", 
        RowBox[{"h", " ", 
         RowBox[{"f", "[", 
          RowBox[{
           RowBox[{"-", "h"}], "+", "x0"}], "]"}]}], "+", 
        RowBox[{"2", " ", "x0", " ", 
         RowBox[{"f", "[", 
          RowBox[{
           RowBox[{"-", "h"}], "+", "x0"}], "]"}]}], "-", 
        RowBox[{"h", " ", 
         RowBox[{"f", "[", 
          RowBox[{"h", "+", "x0"}], "]"}]}], "+", 
        RowBox[{"2", " ", "x0", " ", 
         RowBox[{"f", "[", 
          RowBox[{"h", "+", "x0"}], "]"}]}]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["h", "2"]}]]}]}], ",", 
    RowBox[{
     RowBox[{"a", "[", "2", "]"}], "\[Rule]", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"f", "[", "x0", "]"}]}], "-", 
        RowBox[{"f", "[", 
         RowBox[{
          RowBox[{"-", "h"}], "+", "x0"}], "]"}], "-", 
        RowBox[{"f", "[", 
         RowBox[{"h", "+", "x0"}], "]"}]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["h", "2"]}]]}]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.376605251078125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"Solve", "[", 
   RowBox[{"eqSyst", ",", 
    RowBox[{"Array", "[", 
     RowBox[{"a", ",", "num", ",", "0"}], "]"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.37660526903125*^9, 3.376605293984375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "0", "]"}], "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["h", "2"], "-", 
          SuperscriptBox["x0", "2"]}], ")"}], " ", 
        RowBox[{"f", "[", "x0", "]"}]}], "+", 
       RowBox[{"x0", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"h", "+", "x0"}], ")"}], " ", 
           RowBox[{"f", "[", 
            RowBox[{
             RowBox[{"-", "h"}], "+", "x0"}], "]"}]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "h"}], "+", "x0"}], ")"}], " ", 
           RowBox[{"f", "[", 
            RowBox[{"h", "+", "x0"}], "]"}]}]}], ")"}]}]}], 
      RowBox[{"2", " ", 
       SuperscriptBox["h", "2"]}]]}], ",", 
    RowBox[{
     RowBox[{"a", "[", "1", "]"}], "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"4", " ", "x0", " ", 
        RowBox[{"f", "[", "x0", "]"}]}], "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"h", "+", 
          RowBox[{"2", " ", "x0"}]}], ")"}], " ", 
        RowBox[{"f", "[", 
         RowBox[{
          RowBox[{"-", "h"}], "+", "x0"}], "]"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"h", "-", 
          RowBox[{"2", " ", "x0"}]}], ")"}], " ", 
        RowBox[{"f", "[", 
         RowBox[{"h", "+", "x0"}], "]"}]}]}], 
      RowBox[{"2", " ", 
       SuperscriptBox["h", "2"]}]]}], ",", 
    RowBox[{
     RowBox[{"a", "[", "2", "]"}], "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"f", "[", "x0", "]"}]}], "+", 
       RowBox[{"f", "[", 
        RowBox[{
         RowBox[{"-", "h"}], "+", "x0"}], "]"}], "+", 
       RowBox[{"f", "[", 
        RowBox[{"h", "+", "x0"}], "]"}]}], 
      RowBox[{"2", " ", 
       SuperscriptBox["h", "2"]}]]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.37660529646875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"resEqSyst", "=", 
  RowBox[{
   RowBox[{"Simplify", "[", 
    RowBox[{"Solve", "[", 
     RowBox[{"eqSyst", ",", 
      RowBox[{"Array", "[", 
       RowBox[{"a", ",", "num", ",", "0"}], "]"}]}], "]"}], "]"}], " ", "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.37660532625*^9, 3.376605333390625*^9}, {
  3.37660537321875*^9, 3.376605393296875*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "[", "0", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["h", "2"], "-", 
         SuperscriptBox["x0", "2"]}], ")"}], " ", 
       RowBox[{"f", "[", "x0", "]"}]}], "+", 
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"h", "+", "x0"}], ")"}], " ", 
          RowBox[{"f", "[", 
           RowBox[{
            RowBox[{"-", "h"}], "+", "x0"}], "]"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "h"}], "+", "x0"}], ")"}], " ", 
          RowBox[{"f", "[", 
           RowBox[{"h", "+", "x0"}], "]"}]}]}], ")"}]}]}], 
     RowBox[{"2", " ", 
      SuperscriptBox["h", "2"]}]]}], ",", 
   RowBox[{
    RowBox[{"a", "[", "1", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{
      RowBox[{"4", " ", "x0", " ", 
       RowBox[{"f", "[", "x0", "]"}]}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"h", "+", 
         RowBox[{"2", " ", "x0"}]}], ")"}], " ", 
       RowBox[{"f", "[", 
        RowBox[{
         RowBox[{"-", "h"}], "+", "x0"}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"h", "-", 
         RowBox[{"2", " ", "x0"}]}], ")"}], " ", 
       RowBox[{"f", "[", 
        RowBox[{"h", "+", "x0"}], "]"}]}]}], 
     RowBox[{"2", " ", 
      SuperscriptBox["h", "2"]}]]}], ",", 
   RowBox[{
    RowBox[{"a", "[", "2", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       RowBox[{"f", "[", "x0", "]"}]}], "+", 
      RowBox[{"f", "[", 
       RowBox[{
        RowBox[{"-", "h"}], "+", "x0"}], "]"}], "+", 
      RowBox[{"f", "[", 
       RowBox[{"h", "+", "x0"}], "]"}]}], 
     RowBox[{"2", " ", 
      SuperscriptBox["h", "2"]}]]}]}], "}"}]], "Output",
 CellChangeTimes->{3.376605429109375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Polynom", "=", 
  RowBox[{
   RowBox[{"eq", "[", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}], "]"}], " ", "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.376605498921875*^9, 3.37660554340625*^9}, {
  3.376605607625*^9, 3.376605608046875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", "0", "]"}], "+", 
  RowBox[{"x", " ", 
   RowBox[{"a", "[", "1", "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["x", "2"], " ", 
   RowBox[{"a", "[", "2", "]"}]}]}]], "Output",
 CellChangeTimes->{3.376605554390625*^9, 3.376605612015625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"derPolynom", "=", 
  RowBox[{"D", "[", 
   RowBox[{"Polynom", ",", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.37660561928125*^9, 3.376605644703125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", "1", "]"}], "+", 
  RowBox[{"2", " ", "x", " ", 
   RowBox[{"a", "[", "2", "]"}]}]}]], "Output",
 CellChangeTimes->{3.3766056491875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"der", " ", "=", 
  RowBox[{"derPolynom", "/.", "resEqSyst"}]}]], "Input",
 CellChangeTimes->{{3.376605658015625*^9, 3.37660569090625*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"x", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       RowBox[{"f", "[", "x0", "]"}]}], "+", 
      RowBox[{"f", "[", 
       RowBox[{
        RowBox[{"-", "h"}], "+", "x0"}], "]"}], "+", 
      RowBox[{"f", "[", 
       RowBox[{"h", "+", "x0"}], "]"}]}], ")"}]}], 
   SuperscriptBox["h", "2"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"4", " ", "x0", " ", 
     RowBox[{"f", "[", "x0", "]"}]}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"h", "+", 
       RowBox[{"2", " ", "x0"}]}], ")"}], " ", 
     RowBox[{"f", "[", 
      RowBox[{
       RowBox[{"-", "h"}], "+", "x0"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"h", "-", 
       RowBox[{"2", " ", "x0"}]}], ")"}], " ", 
     RowBox[{"f", "[", 
      RowBox[{"h", "+", "x0"}], "]"}]}]}], 
   RowBox[{"2", " ", 
    SuperscriptBox["h", "2"]}]]}]], "Output",
 CellChangeTimes->{3.3766056945625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"resDer", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{"der", "/.", 
    RowBox[{"x", "\[Rule]", "x0"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.376605705484375*^9, 3.37660575240625*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", 
    RowBox[{"f", "[", 
     RowBox[{
      RowBox[{"-", "h"}], "+", "x0"}], "]"}]}], "+", 
   RowBox[{"f", "[", 
    RowBox[{"h", "+", "x0"}], "]"}]}], 
  RowBox[{"2", " ", "h"}]]], "Output",
 CellChangeTimes->{3.37660575846875*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["3 Point Left Formula", "Section",
 CellChangeTimes->{{3.376604038703125*^9, 3.376604091671875*^9}, {
  3.376604149875*^9, 3.37660416103125*^9}, {3.3766060755*^9, 
  3.3766060765625*^9}}],

Cell[BoxData[{
 RowBox[{"Clear", "[", "\"\<Global`*\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"num", "=", "3"}], ";"}]}], "Input",
 CellChangeTimes->{{3.376604222984375*^9, 3.376604406734375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xVals", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"x0", "+", 
     RowBox[{"i", "*", "h"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", 
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{"num", "-", "1"}], ")"}]}], ",", "0"}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.376604413015625*^9, 3.376604413328125*^9}, {
  3.3766060829375*^9, 3.376606086828125*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], ",", 
   RowBox[{
    RowBox[{"-", "h"}], "+", "x0"}], ",", "x0"}], "}"}]], "Output",
 CellChangeTimes->{3.37660441503125*^9, 3.37660608784375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"yVals", "=", 
  RowBox[{"f", "/@", "xVals"}]}]], "Input",
 CellChangeTimes->{{3.3766044205625*^9, 3.376604420984375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], "]"}], ",", 
   RowBox[{"f", "[", 
    RowBox[{
     RowBox[{"-", "h"}], "+", "x0"}], "]"}], ",", 
   RowBox[{"f", "[", "x0", "]"}]}], "}"}]], "Output",
 CellChangeTimes->{3.376604421859375*^9, 3.37660609371875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pts", "=", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"xVals", ",", "yVals"}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.37660442803125*^9, 3.376604505546875*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "h"}], "+", "x0"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{
       RowBox[{"-", "h"}], "+", "x0"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x0", ",", 
     RowBox[{"f", "[", "x0", "]"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.376604465671875*^9, 3.37660451159375*^9, 
  3.376606095453125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "[", "i", "]"}], "*", 
    RowBox[{"x", "^", "i"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", 
     RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.37660455053125*^9, 3.376604689671875*^9}, {
  3.376604739109375*^9, 3.376604756984375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"a", "[", "0", "]"}], ",", 
   RowBox[{"x", " ", 
    RowBox[{"a", "[", "1", "]"}]}], ",", 
   RowBox[{
    SuperscriptBox["x", "2"], " ", 
    RowBox[{"a", "[", "2", "]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.3766048054375*^9, 3.37660609646875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plus", "@@", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "i", "]"}], "*", 
     RowBox[{"x", "^", "i"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "0", ",", 
      RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.37660481540625*^9, 3.37660482525*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", "0", "]"}], "+", 
  RowBox[{"x", " ", 
   RowBox[{"a", "[", "1", "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["x", "2"], " ", 
   RowBox[{"a", "[", "2", "]"}]}]}]], "Output",
 CellChangeTimes->{3.376604833125*^9, 3.376606097484375*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"eq", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Plus", "@@", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", "i", "]"}], "*", 
       RowBox[{"x", "^", "i"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "0", ",", 
        RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "\[Equal]", 
   "y"}]}]], "Input",
 CellChangeTimes->{{3.376604852640625*^9, 3.376604878765625*^9}, {
  3.376604918234375*^9, 3.37660494153125*^9}, {3.376605024421875*^9, 
  3.376605033828125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eqSyst", "=", 
  RowBox[{"eq", "/@", "pts"}]}]], "Input",
 CellChangeTimes->{{3.376605052859375*^9, 3.37660508734375*^9}, {
   3.376605155453125*^9, 3.376605156046875*^9}, 3.37660611009375*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "0", "]"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], ")"}], " ", 
      RowBox[{"a", "[", "1", "]"}]}], "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], ")"}], "2"], " ", 
      RowBox[{"a", "[", "2", "]"}]}]}], "\[Equal]", 
    RowBox[{"f", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "0", "]"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "h"}], "+", "x0"}], ")"}], " ", 
      RowBox[{"a", "[", "1", "]"}]}], "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "h"}], "+", "x0"}], ")"}], "2"], " ", 
      RowBox[{"a", "[", "2", "]"}]}]}], "\[Equal]", 
    RowBox[{"f", "[", 
     RowBox[{
      RowBox[{"-", "h"}], "+", "x0"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "0", "]"}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"a", "[", "1", "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["x0", "2"], " ", 
      RowBox[{"a", "[", "2", "]"}]}]}], "\[Equal]", 
    RowBox[{"f", "[", "x0", "]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.37660509059375*^9, 3.37660515865625*^9, {3.376606099328125*^9, 
   3.376606110515625*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Array", "[", 
  RowBox[{"a", ",", "num", ",", "0"}], "]"}]], "Input",
 CellChangeTimes->{{3.376605162890625*^9, 3.376605215328125*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"a", "[", "0", "]"}], ",", 
   RowBox[{"a", "[", "1", "]"}], ",", 
   RowBox[{"a", "[", "2", "]"}]}], "}"}]], "Output",
 CellChangeTimes->{3.37660521875*^9, 3.37660610053125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{"eqSyst", ",", 
   RowBox[{"Array", "[", 
    RowBox[{"a", ",", "num", ",", "0"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.376605228640625*^9, 3.37660524809375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "0", "]"}], "\[Rule]", 
     RowBox[{"-", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"2", " ", 
         SuperscriptBox["h", "2"]}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          SuperscriptBox["h", "2"], " ", 
          RowBox[{"f", "[", "x0", "]"}]}], "+", 
         RowBox[{"3", " ", "h", " ", "x0", " ", 
          RowBox[{"f", "[", "x0", "]"}]}], "-", 
         RowBox[{
          SuperscriptBox["x0", "2"], " ", 
          RowBox[{"f", "[", "x0", "]"}]}], "+", 
         RowBox[{"h", " ", "x0", " ", 
          RowBox[{"f", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], "]"}]}], "-", 
         RowBox[{
          SuperscriptBox["x0", "2"], " ", 
          RowBox[{"f", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], "]"}]}], "-", 
         RowBox[{"4", " ", "h", " ", "x0", " ", 
          RowBox[{"f", "[", 
           RowBox[{
            RowBox[{"-", "h"}], "+", "x0"}], "]"}]}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox["x0", "2"], " ", 
          RowBox[{"f", "[", 
           RowBox[{
            RowBox[{"-", "h"}], "+", "x0"}], "]"}]}]}], ")"}]}]}]}], ",", 
    RowBox[{
     RowBox[{"a", "[", "1", "]"}], "\[Rule]", 
     RowBox[{"-", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"2", " ", 
         SuperscriptBox["h", "2"]}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "3"}], " ", "h", " ", 
          RowBox[{"f", "[", "x0", "]"}]}], "+", 
         RowBox[{"2", " ", "x0", " ", 
          RowBox[{"f", "[", "x0", "]"}]}], "-", 
         RowBox[{"h", " ", 
          RowBox[{"f", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], "]"}]}], "+", 
         RowBox[{"2", " ", "x0", " ", 
          RowBox[{"f", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], "]"}]}], "+", 
         RowBox[{"4", " ", "h", " ", 
          RowBox[{"f", "[", 
           RowBox[{
            RowBox[{"-", "h"}], "+", "x0"}], "]"}]}], "-", 
         RowBox[{"4", " ", "x0", " ", 
          RowBox[{"f", "[", 
           RowBox[{
            RowBox[{"-", "h"}], "+", "x0"}], "]"}]}]}], ")"}]}]}]}], ",", 
    RowBox[{
     RowBox[{"a", "[", "2", "]"}], "\[Rule]", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        RowBox[{"-", 
         RowBox[{"f", "[", "x0", "]"}]}], "-", 
        RowBox[{"f", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], "]"}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"f", "[", 
          RowBox[{
           RowBox[{"-", "h"}], "+", "x0"}], "]"}]}]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["h", "2"]}]]}]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.376605251078125*^9, {3.37660610171875*^9, 3.376606113671875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"Solve", "[", 
   RowBox[{"eqSyst", ",", 
    RowBox[{"Array", "[", 
     RowBox[{"a", ",", "num", ",", "0"}], "]"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.37660526903125*^9, 3.376605293984375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "0", "]"}], "\[Rule]", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"2", " ", 
        SuperscriptBox["h", "2"]}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", 
            SuperscriptBox["h", "2"]}], "-", 
           RowBox[{"3", " ", "h", " ", "x0"}], "+", 
           SuperscriptBox["x0", "2"]}], ")"}], " ", 
         RowBox[{"f", "[", "x0", "]"}]}], "+", 
        RowBox[{"x0", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "h"}], "+", "x0"}], ")"}], " ", 
            RowBox[{"f", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], "]"}]}], "+", 
           RowBox[{"2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "h"}], "-", "x0"}], ")"}], " ", 
            RowBox[{"f", "[", 
             RowBox[{
              RowBox[{"-", "h"}], "+", "x0"}], "]"}]}]}], ")"}]}]}], 
       ")"}]}]}], ",", 
    RowBox[{
     RowBox[{"a", "[", "1", "]"}], "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", " ", "h"}], "-", 
          RowBox[{"2", " ", "x0"}]}], ")"}], " ", 
        RowBox[{"f", "[", "x0", "]"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"h", "-", 
          RowBox[{"2", " ", "x0"}]}], ")"}], " ", 
        RowBox[{"f", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], "]"}]}], "+", 
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "h"}], "+", "x0"}], ")"}], " ", 
        RowBox[{"f", "[", 
         RowBox[{
          RowBox[{"-", "h"}], "+", "x0"}], "]"}]}]}], 
      RowBox[{"2", " ", 
       SuperscriptBox["h", "2"]}]]}], ",", 
    RowBox[{
     RowBox[{"a", "[", "2", "]"}], "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"f", "[", "x0", "]"}], "+", 
       RowBox[{"f", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], "]"}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"f", "[", 
         RowBox[{
          RowBox[{"-", "h"}], "+", "x0"}], "]"}]}]}], 
      RowBox[{"2", " ", 
       SuperscriptBox["h", "2"]}]]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.37660529646875*^9, 3.37660611553125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"resEqSyst", "=", 
  RowBox[{
   RowBox[{"Simplify", "[", 
    RowBox[{"Solve", "[", 
     RowBox[{"eqSyst", ",", 
      RowBox[{"Array", "[", 
       RowBox[{"a", ",", "num", ",", "0"}], "]"}]}], "]"}], "]"}], " ", "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.37660532625*^9, 3.376605333390625*^9}, {
  3.37660537321875*^9, 3.376605393296875*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "[", "0", "]"}], "\[Rule]", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"2", " ", 
       SuperscriptBox["h", "2"]}]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", 
           SuperscriptBox["h", "2"]}], "-", 
          RowBox[{"3", " ", "h", " ", "x0"}], "+", 
          SuperscriptBox["x0", "2"]}], ")"}], " ", 
        RowBox[{"f", "[", "x0", "]"}]}], "+", 
       RowBox[{"x0", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "h"}], "+", "x0"}], ")"}], " ", 
           RowBox[{"f", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], "]"}]}], "+", 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "h"}], "-", "x0"}], ")"}], " ", 
           RowBox[{"f", "[", 
            RowBox[{
             RowBox[{"-", "h"}], "+", "x0"}], "]"}]}]}], ")"}]}]}], ")"}]}]}],
    ",", 
   RowBox[{
    RowBox[{"a", "[", "1", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"3", " ", "h"}], "-", 
         RowBox[{"2", " ", "x0"}]}], ")"}], " ", 
       RowBox[{"f", "[", "x0", "]"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"h", "-", 
         RowBox[{"2", " ", "x0"}]}], ")"}], " ", 
       RowBox[{"f", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "h"}], "+", "x0"}], ")"}], " ", 
       RowBox[{"f", "[", 
        RowBox[{
         RowBox[{"-", "h"}], "+", "x0"}], "]"}]}]}], 
     RowBox[{"2", " ", 
      SuperscriptBox["h", "2"]}]]}], ",", 
   RowBox[{
    RowBox[{"a", "[", "2", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{
      RowBox[{"f", "[", "x0", "]"}], "+", 
      RowBox[{"f", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], "]"}], "-", 
      RowBox[{"2", " ", 
       RowBox[{"f", "[", 
        RowBox[{
         RowBox[{"-", "h"}], "+", "x0"}], "]"}]}]}], 
     RowBox[{"2", " ", 
      SuperscriptBox["h", "2"]}]]}]}], "}"}]], "Output",
 CellChangeTimes->{3.376605429109375*^9, 3.37660611784375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Polynom", "=", 
  RowBox[{
   RowBox[{"eq", "[", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}], "]"}], " ", "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.376605498921875*^9, 3.37660554340625*^9}, {
  3.376605607625*^9, 3.376605608046875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", "0", "]"}], "+", 
  RowBox[{"x", " ", 
   RowBox[{"a", "[", "1", "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["x", "2"], " ", 
   RowBox[{"a", "[", "2", "]"}]}]}]], "Output",
 CellChangeTimes->{3.376605554390625*^9, 3.376605612015625*^9, 
  3.376606119625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"derPolynom", "=", 
  RowBox[{"D", "[", 
   RowBox[{"Polynom", ",", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.37660561928125*^9, 3.376605644703125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", "1", "]"}], "+", 
  RowBox[{"2", " ", "x", " ", 
   RowBox[{"a", "[", "2", "]"}]}]}]], "Output",
 CellChangeTimes->{3.3766056491875*^9, 3.376606120453125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"der", " ", "=", 
  RowBox[{"derPolynom", "/.", "resEqSyst"}]}]], "Input",
 CellChangeTimes->{{3.376605658015625*^9, 3.37660569090625*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"x", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"f", "[", "x0", "]"}], "+", 
      RowBox[{"f", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], "]"}], "-", 
      RowBox[{"2", " ", 
       RowBox[{"f", "[", 
        RowBox[{
         RowBox[{"-", "h"}], "+", "x0"}], "]"}]}]}], ")"}]}], 
   SuperscriptBox["h", "2"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", " ", "h"}], "-", 
       RowBox[{"2", " ", "x0"}]}], ")"}], " ", 
     RowBox[{"f", "[", "x0", "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"h", "-", 
       RowBox[{"2", " ", "x0"}]}], ")"}], " ", 
     RowBox[{"f", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], "]"}]}], "+", 
    RowBox[{"4", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "h"}], "+", "x0"}], ")"}], " ", 
     RowBox[{"f", "[", 
      RowBox[{
       RowBox[{"-", "h"}], "+", "x0"}], "]"}]}]}], 
   RowBox[{"2", " ", 
    SuperscriptBox["h", "2"]}]]}]], "Output",
 CellChangeTimes->{3.3766056945625*^9, 3.376606121375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"resDer", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{"der", "/.", 
    RowBox[{"x", "\[Rule]", "x0"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.376605705484375*^9, 3.37660575240625*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"3", " ", 
    RowBox[{"f", "[", "x0", "]"}]}], "+", 
   RowBox[{"f", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", "h"}], "+", "x0"}], "]"}], "-", 
   RowBox[{"4", " ", 
    RowBox[{"f", "[", 
     RowBox[{
      RowBox[{"-", "h"}], "+", "x0"}], "]"}]}]}], 
  RowBox[{"2", " ", "h"}]]], "Output",
 CellChangeTimes->{3.37660575846875*^9, 3.37660612290625*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["3 Point Right Formula", "Section",
 CellChangeTimes->{{3.376604038703125*^9, 3.376604091671875*^9}, {
  3.376604149875*^9, 3.37660416103125*^9}, {3.3766060755*^9, 
  3.3766060765625*^9}, {3.376606136234375*^9, 3.376606137359375*^9}}],

Cell[BoxData[{
 RowBox[{"Clear", "[", "\"\<Global`*\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"num", "=", "3"}], ";"}]}], "Input",
 CellChangeTimes->{{3.376604222984375*^9, 3.376604406734375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xVals", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"x0", "+", 
     RowBox[{"i", "*", "h"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "0", ",", 
      RowBox[{"(", 
       RowBox[{"num", "-", "1"}], ")"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.376604413015625*^9, 3.376604413328125*^9}, {
  3.3766060829375*^9, 3.376606086828125*^9}, {3.3766061646875*^9, 
  3.3766062169375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"x0", ",", 
   RowBox[{"h", "+", "x0"}], ",", 
   RowBox[{
    RowBox[{"2", " ", "h"}], "+", "x0"}]}], "}"}]], "Output",
 CellChangeTimes->{3.37660441503125*^9, 3.37660608784375*^9, 
  3.3766062229375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"yVals", "=", 
  RowBox[{"f", "/@", "xVals"}]}]], "Input",
 CellChangeTimes->{{3.3766044205625*^9, 3.376604420984375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"f", "[", "x0", "]"}], ",", 
   RowBox[{"f", "[", 
    RowBox[{"h", "+", "x0"}], "]"}], ",", 
   RowBox[{"f", "[", 
    RowBox[{
     RowBox[{"2", " ", "h"}], "+", "x0"}], "]"}]}], "}"}]], "Output",
 CellChangeTimes->{3.376604421859375*^9, 3.37660609371875*^9, 
  3.37660622753125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"pts", "=", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"xVals", ",", "yVals"}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.37660442803125*^9, 3.376604505546875*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x0", ",", 
     RowBox[{"f", "[", "x0", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"h", "+", "x0"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{"h", "+", "x0"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"2", " ", "h"}], "+", "x0"}], ",", 
     RowBox[{"f", "[", 
      RowBox[{
       RowBox[{"2", " ", "h"}], "+", "x0"}], "]"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.376604465671875*^9, 3.37660451159375*^9, 
  3.376606095453125*^9, 3.376606229625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "[", "i", "]"}], "*", 
    RowBox[{"x", "^", "i"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "0", ",", 
     RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.37660455053125*^9, 3.376604689671875*^9}, {
  3.376604739109375*^9, 3.376604756984375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"a", "[", "0", "]"}], ",", 
   RowBox[{"x", " ", 
    RowBox[{"a", "[", "1", "]"}]}], ",", 
   RowBox[{
    SuperscriptBox["x", "2"], " ", 
    RowBox[{"a", "[", "2", "]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.3766048054375*^9, 3.37660609646875*^9, 
  3.37660623134375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plus", "@@", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "i", "]"}], "*", 
     RowBox[{"x", "^", "i"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "0", ",", 
      RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.37660481540625*^9, 3.37660482525*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", "0", "]"}], "+", 
  RowBox[{"x", " ", 
   RowBox[{"a", "[", "1", "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["x", "2"], " ", 
   RowBox[{"a", "[", "2", "]"}]}]}]], "Output",
 CellChangeTimes->{3.376604833125*^9, 3.376606097484375*^9, 
  3.376606233671875*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"eq", "[", 
   RowBox[{"{", 
    RowBox[{"x_", ",", "y_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Plus", "@@", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"a", "[", "i", "]"}], "*", 
       RowBox[{"x", "^", "i"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "0", ",", 
        RowBox[{"num", "-", "1"}]}], "}"}]}], "]"}]}], "\[Equal]", 
   "y"}]}]], "Input",
 CellChangeTimes->{{3.376604852640625*^9, 3.376604878765625*^9}, {
  3.376604918234375*^9, 3.37660494153125*^9}, {3.376605024421875*^9, 
  3.376605033828125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eqSyst", "=", 
  RowBox[{"eq", "/@", "pts"}]}]], "Input",
 CellChangeTimes->{{3.376605052859375*^9, 3.37660508734375*^9}, {
   3.376605155453125*^9, 3.376605156046875*^9}, 3.37660611009375*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "0", "]"}], "+", 
     RowBox[{"x0", " ", 
      RowBox[{"a", "[", "1", "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["x0", "2"], " ", 
      RowBox[{"a", "[", "2", "]"}]}]}], "\[Equal]", 
    RowBox[{"f", "[", "x0", "]"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "0", "]"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"h", "+", "x0"}], ")"}], " ", 
      RowBox[{"a", "[", "1", "]"}]}], "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"h", "+", "x0"}], ")"}], "2"], " ", 
      RowBox[{"a", "[", "2", "]"}]}]}], "\[Equal]", 
    RowBox[{"f", "[", 
     RowBox[{"h", "+", "x0"}], "]"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "0", "]"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "h"}], "+", "x0"}], ")"}], " ", 
      RowBox[{"a", "[", "1", "]"}]}], "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "h"}], "+", "x0"}], ")"}], "2"], " ", 
      RowBox[{"a", "[", "2", "]"}]}]}], "\[Equal]", 
    RowBox[{"f", "[", 
     RowBox[{
      RowBox[{"2", " ", "h"}], "+", "x0"}], "]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.37660509059375*^9, 3.37660515865625*^9, {3.376606099328125*^9, 
   3.376606110515625*^9}, 3.376606238859375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Array", "[", 
  RowBox[{"a", ",", "num", ",", "0"}], "]"}]], "Input",
 CellChangeTimes->{{3.376605162890625*^9, 3.376605215328125*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"a", "[", "0", "]"}], ",", 
   RowBox[{"a", "[", "1", "]"}], ",", 
   RowBox[{"a", "[", "2", "]"}]}], "}"}]], "Output",
 CellChangeTimes->{3.37660521875*^9, 3.37660610053125*^9, 3.376606241*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{"eqSyst", ",", 
   RowBox[{"Array", "[", 
    RowBox[{"a", ",", "num", ",", "0"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.376605228640625*^9, 3.37660524809375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "0", "]"}], "\[Rule]", 
     RowBox[{"-", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"2", " ", 
         SuperscriptBox["h", "2"]}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          SuperscriptBox["h", "2"], " ", 
          RowBox[{"f", "[", "x0", "]"}]}], "-", 
         RowBox[{"3", " ", "h", " ", "x0", " ", 
          RowBox[{"f", "[", "x0", "]"}]}], "-", 
         RowBox[{
          SuperscriptBox["x0", "2"], " ", 
          RowBox[{"f", "[", "x0", "]"}]}], "+", 
         RowBox[{"4", " ", "h", " ", "x0", " ", 
          RowBox[{"f", "[", 
           RowBox[{"h", "+", "x0"}], "]"}]}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox["x0", "2"], " ", 
          RowBox[{"f", "[", 
           RowBox[{"h", "+", "x0"}], "]"}]}], "-", 
         RowBox[{"h", " ", "x0", " ", 
          RowBox[{"f", "[", 
           RowBox[{
            RowBox[{"2", " ", "h"}], "+", "x0"}], "]"}]}], "-", 
         RowBox[{
          SuperscriptBox["x0", "2"], " ", 
          RowBox[{"f", "[", 
           RowBox[{
            RowBox[{"2", " ", "h"}], "+", "x0"}], "]"}]}]}], ")"}]}]}]}], ",", 
    RowBox[{
     RowBox[{"a", "[", "1", "]"}], "\[Rule]", 
     RowBox[{"-", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"2", " ", 
         SuperscriptBox["h", "2"]}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"3", " ", "h", " ", 
          RowBox[{"f", "[", "x0", "]"}]}], "+", 
         RowBox[{"2", " ", "x0", " ", 
          RowBox[{"f", "[", "x0", "]"}]}], "-", 
         RowBox[{"4", " ", "h", " ", 
          RowBox[{"f", "[", 
           RowBox[{"h", "+", "x0"}], "]"}]}], "-", 
         RowBox[{"4", " ", "x0", " ", 
          RowBox[{"f", "[", 
           RowBox[{"h", "+", "x0"}], "]"}]}], "+", 
         RowBox[{"h", " ", 
          RowBox[{"f", "[", 
           RowBox[{
            RowBox[{"2", " ", "h"}], "+", "x0"}], "]"}]}], "+", 
         RowBox[{"2", " ", "x0", " ", 
          RowBox[{"f", "[", 
           RowBox[{
            RowBox[{"2", " ", "h"}], "+", "x0"}], "]"}]}]}], ")"}]}]}]}], ",", 
    RowBox[{
     RowBox[{"a", "[", "2", "]"}], "\[Rule]", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        RowBox[{"-", 
         RowBox[{"f", "[", "x0", "]"}]}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"f", "[", 
          RowBox[{"h", "+", "x0"}], "]"}]}], "-", 
        RowBox[{"f", "[", 
         RowBox[{
          RowBox[{"2", " ", "h"}], "+", "x0"}], "]"}]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["h", "2"]}]]}]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.376605251078125*^9, {3.37660610171875*^9, 3.376606113671875*^9}, 
   3.3766062434375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"Solve", "[", 
   RowBox[{"eqSyst", ",", 
    RowBox[{"Array", "[", 
     RowBox[{"a", ",", "num", ",", "0"}], "]"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.37660526903125*^9, 3.376605293984375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "[", "0", "]"}], "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", 
           SuperscriptBox["h", "2"]}], "+", 
          RowBox[{"3", " ", "h", " ", "x0"}], "+", 
          SuperscriptBox["x0", "2"]}], ")"}], " ", 
        RowBox[{"f", "[", "x0", "]"}]}], "+", 
       RowBox[{"x0", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "2"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", "h"}], "+", "x0"}], ")"}], " ", 
           RowBox[{"f", "[", 
            RowBox[{"h", "+", "x0"}], "]"}]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"h", "+", "x0"}], ")"}], " ", 
           RowBox[{"f", "[", 
            RowBox[{
             RowBox[{"2", " ", "h"}], "+", "x0"}], "]"}]}]}], ")"}]}]}], 
      RowBox[{"2", " ", 
       SuperscriptBox["h", "2"]}]]}], ",", 
    RowBox[{
     RowBox[{"a", "[", "1", "]"}], "\[Rule]", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"3", " ", "h"}], "+", 
           RowBox[{"2", " ", "x0"}]}], ")"}], " ", 
         RowBox[{"f", "[", "x0", "]"}]}], "-", 
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{"h", "+", "x0"}], ")"}], " ", 
         RowBox[{"f", "[", 
          RowBox[{"h", "+", "x0"}], "]"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"h", "+", 
           RowBox[{"2", " ", "x0"}]}], ")"}], " ", 
         RowBox[{"f", "[", 
          RowBox[{
           RowBox[{"2", " ", "h"}], "+", "x0"}], "]"}]}]}], 
       RowBox[{"2", " ", 
        SuperscriptBox["h", "2"]}]]}]}], ",", 
    RowBox[{
     RowBox[{"a", "[", "2", "]"}], "\[Rule]", 
     FractionBox[
      RowBox[{
       RowBox[{"f", "[", "x0", "]"}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"f", "[", 
         RowBox[{"h", "+", "x0"}], "]"}]}], "+", 
       RowBox[{"f", "[", 
        RowBox[{
         RowBox[{"2", " ", "h"}], "+", "x0"}], "]"}]}], 
      RowBox[{"2", " ", 
       SuperscriptBox["h", "2"]}]]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.37660529646875*^9, 3.37660611553125*^9, 
  3.376606245640625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"resEqSyst", "=", 
  RowBox[{
   RowBox[{"Simplify", "[", 
    RowBox[{"Solve", "[", 
     RowBox[{"eqSyst", ",", 
      RowBox[{"Array", "[", 
       RowBox[{"a", ",", "num", ",", "0"}], "]"}]}], "]"}], "]"}], " ", "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.37660532625*^9, 3.376605333390625*^9}, {
  3.37660537321875*^9, 3.376605393296875*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "[", "0", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", 
          SuperscriptBox["h", "2"]}], "+", 
         RowBox[{"3", " ", "h", " ", "x0"}], "+", 
         SuperscriptBox["x0", "2"]}], ")"}], " ", 
       RowBox[{"f", "[", "x0", "]"}]}], "+", 
      RowBox[{"x0", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "h"}], "+", "x0"}], ")"}], " ", 
          RowBox[{"f", "[", 
           RowBox[{"h", "+", "x0"}], "]"}]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"h", "+", "x0"}], ")"}], " ", 
          RowBox[{"f", "[", 
           RowBox[{
            RowBox[{"2", " ", "h"}], "+", "x0"}], "]"}]}]}], ")"}]}]}], 
     RowBox[{"2", " ", 
      SuperscriptBox["h", "2"]}]]}], ",", 
   RowBox[{
    RowBox[{"a", "[", "1", "]"}], "\[Rule]", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", " ", "h"}], "+", 
          RowBox[{"2", " ", "x0"}]}], ")"}], " ", 
        RowBox[{"f", "[", "x0", "]"}]}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{"h", "+", "x0"}], ")"}], " ", 
        RowBox[{"f", "[", 
         RowBox[{"h", "+", "x0"}], "]"}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"h", "+", 
          RowBox[{"2", " ", "x0"}]}], ")"}], " ", 
        RowBox[{"f", "[", 
         RowBox[{
          RowBox[{"2", " ", "h"}], "+", "x0"}], "]"}]}]}], 
      RowBox[{"2", " ", 
       SuperscriptBox["h", "2"]}]]}]}], ",", 
   RowBox[{
    RowBox[{"a", "[", "2", "]"}], "\[Rule]", 
    FractionBox[
     RowBox[{
      RowBox[{"f", "[", "x0", "]"}], "-", 
      RowBox[{"2", " ", 
       RowBox[{"f", "[", 
        RowBox[{"h", "+", "x0"}], "]"}]}], "+", 
      RowBox[{"f", "[", 
       RowBox[{
        RowBox[{"2", " ", "h"}], "+", "x0"}], "]"}]}], 
     RowBox[{"2", " ", 
      SuperscriptBox["h", "2"]}]]}]}], "}"}]], "Output",
 CellChangeTimes->{3.376605429109375*^9, 3.37660611784375*^9, 
  3.3766062480625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Polynom", "=", 
  RowBox[{
   RowBox[{"eq", "[", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}], "]"}], " ", "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.376605498921875*^9, 3.37660554340625*^9}, {
  3.376605607625*^9, 3.376605608046875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", "0", "]"}], "+", 
  RowBox[{"x", " ", 
   RowBox[{"a", "[", "1", "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["x", "2"], " ", 
   RowBox[{"a", "[", "2", "]"}]}]}]], "Output",
 CellChangeTimes->{3.376605554390625*^9, 3.376605612015625*^9, 
  3.376606119625*^9, 3.376606250234375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"derPolynom", "=", 
  RowBox[{"D", "[", 
   RowBox[{"Polynom", ",", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.37660561928125*^9, 3.376605644703125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"a", "[", "1", "]"}], "+", 
  RowBox[{"2", " ", "x", " ", 
   RowBox[{"a", "[", "2", "]"}]}]}]], "Output",
 CellChangeTimes->{3.3766056491875*^9, 3.376606120453125*^9, 
  3.376606254328125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"der", " ", "=", 
  RowBox[{"derPolynom", "/.", "resEqSyst"}]}]], "Input",
 CellChangeTimes->{{3.376605658015625*^9, 3.37660569090625*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"x", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"f", "[", "x0", "]"}], "-", 
      RowBox[{"2", " ", 
       RowBox[{"f", "[", 
        RowBox[{"h", "+", "x0"}], "]"}]}], "+", 
      RowBox[{"f", "[", 
       RowBox[{
        RowBox[{"2", " ", "h"}], "+", "x0"}], "]"}]}], ")"}]}], 
   SuperscriptBox["h", "2"]], "-", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", " ", "h"}], "+", 
       RowBox[{"2", " ", "x0"}]}], ")"}], " ", 
     RowBox[{"f", "[", "x0", "]"}]}], "-", 
    RowBox[{"4", " ", 
     RowBox[{"(", 
      RowBox[{"h", "+", "x0"}], ")"}], " ", 
     RowBox[{"f", "[", 
      RowBox[{"h", "+", "x0"}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"h", "+", 
       RowBox[{"2", " ", "x0"}]}], ")"}], " ", 
     RowBox[{"f", "[", 
      RowBox[{
       RowBox[{"2", " ", "h"}], "+", "x0"}], "]"}]}]}], 
   RowBox[{"2", " ", 
    SuperscriptBox["h", "2"]}]]}]], "Output",
 CellChangeTimes->{3.3766056945625*^9, 3.376606121375*^9, 
  3.376606256203125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"resDer", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{"der", "/.", 
    RowBox[{"x", "\[Rule]", "x0"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.376605705484375*^9, 3.37660575240625*^9}}],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    RowBox[{"3", " ", 
     RowBox[{"f", "[", "x0", "]"}]}], "-", 
    RowBox[{"4", " ", 
     RowBox[{"f", "[", 
      RowBox[{"h", "+", "x0"}], "]"}]}], "+", 
    RowBox[{"f", "[", 
     RowBox[{
      RowBox[{"2", " ", "h"}], "+", "x0"}], "]"}]}], 
   RowBox[{"2", " ", "h"}]]}]], "Output",
 CellChangeTimes->{3.37660575846875*^9, 3.37660612290625*^9, 
  3.376606258140625*^9}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{615, 750},
WindowMargins->{{137, Automatic}, {Automatic, 48}},
FrontEndVersion->"7.0 for Microsoft Windows (32-bit) (November 10, 2008)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 227, 4, 31, "Input"],
Cell[797, 28, 194, 7, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1028, 40, 156, 3, 31, "Input"],
Cell[1187, 45, 102, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1326, 52, 205, 5, 31, "Input"],
Cell[1534, 59, 206, 5, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1777, 69, 86, 2, 31, "Input"],
Cell[1866, 73, 153, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2056, 80, 210, 5, 31, "Input"],
Cell[2269, 87, 227, 6, 47, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2533, 98, 143, 3, 31, "Input"],
Cell[2679, 103, 329, 9, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3045, 117, 144, 3, 31, "Input"],
Cell[3192, 122, 101, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3330, 129, 147, 3, 31, "Input"],
Cell[3480, 134, 207, 5, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3724, 144, 153, 3, 31, "Input"],
Cell[3880, 149, 101, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4018, 156, 236, 6, 31, "Input"],
Cell[4257, 164, 113, 3, 47, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4407, 172, 217, 5, 31, "Input"],
Cell[4627, 179, 191, 4, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4855, 188, 149, 3, 31, "Input"],
Cell[5007, 193, 145, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5189, 201, 153, 2, 71, "Section"],
Cell[5345, 205, 211, 4, 52, "Input"],
Cell[CellGroupData[{
Cell[5581, 213, 489, 16, 31, "Input"],
Cell[6073, 231, 195, 6, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6305, 242, 145, 3, 31, "Input"],
Cell[6453, 247, 286, 9, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6776, 261, 209, 5, 31, "Input"],
Cell[6988, 268, 543, 18, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7568, 291, 361, 10, 31, "Input"],
Cell[7932, 303, 286, 9, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8255, 317, 342, 10, 31, "Input"],
Cell[8600, 329, 256, 8, 30, "Output"]
}, Open  ]],
Cell[8871, 340, 599, 18, 31, "Input"],
Cell[CellGroupData[{
Cell[9495, 362, 195, 4, 31, "Input"],
Cell[9693, 368, 1314, 43, 73, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11044, 416, 159, 3, 31, "Input"],
Cell[11206, 421, 208, 6, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11451, 432, 221, 5, 31, "Input"],
Cell[11675, 439, 2432, 74, 145, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14144, 518, 259, 6, 31, "Input"],
Cell[14406, 526, 2060, 66, 129, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16503, 597, 401, 10, 31, "Input"],
Cell[16907, 609, 1975, 65, 129, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18919, 679, 304, 8, 31, "Input"],
Cell[19226, 689, 281, 8, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19544, 702, 181, 4, 31, "Input"],
Cell[19728, 708, 180, 5, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19945, 718, 162, 3, 31, "Input"],
Cell[20110, 723, 979, 34, 85, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21126, 762, 217, 5, 31, "Input"],
Cell[21346, 769, 288, 10, 48, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[21683, 785, 192, 3, 41, "Section"],
Cell[21878, 790, 211, 4, 52, "Input"],
Cell[CellGroupData[{
Cell[22114, 798, 420, 13, 31, "Input"],
Cell[22537, 813, 262, 8, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22836, 826, 145, 3, 31, "Input"],
Cell[22984, 831, 355, 11, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23376, 847, 209, 5, 31, "Input"],
Cell[23588, 854, 670, 23, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24295, 882, 361, 10, 31, "Input"],
Cell[24659, 894, 307, 9, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25003, 908, 342, 10, 31, "Input"],
Cell[25348, 920, 278, 8, 30, "Output"]
}, Open  ]],
Cell[25641, 931, 599, 18, 31, "Input"],
Cell[CellGroupData[{
Cell[26265, 953, 217, 4, 31, "Input"],
Cell[26485, 959, 1527, 51, 73, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28049, 1015, 159, 3, 31, "Input"],
Cell[28211, 1020, 229, 6, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28477, 1031, 221, 5, 31, "Input"],
Cell[28701, 1038, 3089, 92, 164, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31827, 1135, 259, 6, 31, "Input"],
Cell[32089, 1143, 2557, 81, 145, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[34683, 1229, 401, 10, 31, "Input"],
Cell[35087, 1241, 2454, 80, 145, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37578, 1326, 304, 8, 31, "Input"],
Cell[37885, 1336, 303, 9, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38225, 1350, 181, 4, 31, "Input"],
Cell[38409, 1356, 202, 5, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38648, 1366, 162, 3, 31, "Input"],
Cell[38813, 1371, 1187, 41, 85, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40037, 1417, 217, 5, 31, "Input"],
Cell[40257, 1424, 427, 14, 48, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[40733, 1444, 239, 3, 41, "Section"],
Cell[40975, 1449, 211, 4, 52, "Input"],
Cell[CellGroupData[{
Cell[41211, 1457, 437, 12, 31, "Input"],
Cell[41651, 1471, 244, 7, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41932, 1483, 145, 3, 31, "Input"],
Cell[42080, 1488, 336, 10, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42453, 1503, 209, 5, 31, "Input"],
Cell[42665, 1510, 600, 20, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[43302, 1535, 361, 10, 31, "Input"],
Cell[43666, 1547, 331, 10, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[44034, 1562, 342, 10, 31, "Input"],
Cell[44379, 1574, 303, 9, 30, "Output"]
}, Open  ]],
Cell[44697, 1586, 599, 18, 31, "Input"],
Cell[CellGroupData[{
Cell[45321, 1608, 217, 4, 31, "Input"],
Cell[45541, 1614, 1404, 45, 73, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[46982, 1664, 159, 3, 31, "Input"],
Cell[47144, 1669, 245, 6, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[47426, 1680, 221, 5, 31, "Input"],
Cell[47650, 1687, 2805, 82, 164, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[50492, 1774, 259, 6, 31, "Input"],
Cell[50754, 1782, 2347, 73, 175, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[53138, 1860, 401, 10, 31, "Input"],
Cell[53542, 1872, 2254, 72, 156, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[55833, 1949, 304, 8, 31, "Input"],
Cell[56140, 1959, 325, 9, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[56502, 1973, 181, 4, 31, "Input"],
Cell[56686, 1979, 227, 6, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[56950, 1990, 162, 3, 31, "Input"],
Cell[57115, 1995, 1092, 37, 85, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[58244, 2037, 217, 5, 31, "Input"],
Cell[58464, 2044, 436, 14, 48, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
